import type { BasicFormItem, BasicForm } from '@/types/form'
import type { FormProps } from 'element-plus'

export const useFormDesignerStore = defineStore({
  id: 'formDesigner',
  state: () => ({
    formItems: <BasicFormItem[]>[],
    formProps: <Partial<FormProps>>{
      labelWidth: 100,
      labelPosition: 'top',
      size: 'large'
    },
    formSpan: 24,
    curFormItem: <any>{}
  }),
  getters: {
    tableItems: state => state.formItems.filter(item => item.list),
    downloadFormItems: state => {
      return state.formItems.map(item => {
        const element = JSON.parse(JSON.stringify(item))
        delete element.id
        delete element.list
        !element.children.length && delete element.children
        !element.options.length && delete element.options
        !element.required && delete element.required
        !element.search && delete element.search
        !element.request && delete element.request
        if (element.span === 12) {
          delete element.span
        }
        return element
      })
    }
  },
  actions: {
    setFormItems(formItem: BasicFormItem) {
      this.formItems.push(formItem)
    },
    setCurFormItem(formItem: BasicFormItem) {
      this.curFormItem = formItem
    }
  }
})


export const designerType = defineStore({
  id: 'Type',
  state: () => ({
    type:0
  }),
  getters: {},
  actions: {}
})